ExcludeArch: %{ix86}

Name:           ocaml-camlidl
Version:        1.11
Release:    1%{?dist}
Summary:        Stub code generator and COM binding for Objective Caml
License:        LGPL-2.1-or-later WITH OCaml-LGPL-linking-exception

%global shortversion %(tr -d . <<< %{version})

URL:            https://xavierleroy.org/camlidl/
Source0:        https://github.com/xavierleroy/camlidl/archive/camlidl%{shortversion}.tar.gz
Source1:        https://raw.githubusercontent.com/ocaml/opam-repository/master/packages/camlidl/camlidl.%{version}/files/META

Patch1:         0001-Allow-destdir-installs.patch
Patch2:         0002-Pass-g-option-to-ocamlmklib.patch

BuildRequires:  make
BuildRequires:  ocaml
BuildRequires:  ocaml-ocamldoc
BuildRequires:  perl-interpreter
BuildRequires:  python3


%description
CamlIDL is a stub code generator and COM binding for Objective Caml.

CamlIDL comprises two parts:

* A stub code generator that generates the C stub code required for
  the Caml/C interface, based on an MIDL specification. (MIDL stands
  for Microsoft's Interface Description Language; it looks like C
  header files with some extra annotations, plus a notion of object
  interfaces that look like C++ classes without inheritance.)

* A (currently small) library of functions and tools to import COM
  components in Caml applications, and export Caml code as COM
  components.


%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}


%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.


%prep
%autosetup -n camlidl-camlidl%{shortversion} -p1

sed -e 's|^OCAMLLIB=.*|OCAMLLIB=%{_libdir}/ocaml|' \
    -e 's|^BINDIR=.*|BINDIR=%{_bindir}|' \
    -e 's|^CFLAGS=.*|CFLAGS=%{build_cflags}|' \
%ifarch %{ocaml_native_compiler}
    -e 's|^OCAMLC=.*|OCAMLC=ocamlc.opt -g|' \
    -e 's|^OCAMLOPT=.*|OCAMLOPT=ocamlopt.opt -g|' \
%endif
    < config/Makefile.unix \
    > config/Makefile

%ifnarch %{ocaml_native_compiler}
sed -e 's/\(all: \$(BYTELIB)\).*/\1/' \
    -e 's/ \$(NATIVELIB) \$(NATIVELIB:.cmxa=\.\$(LIBEXT))//' \
    -e '/RANLIB/d' \
    -i lib/Makefile
%endif

find . \( -name .cvsignore -o -name .gitignore \) -delete

sed -i 's/cp/cp -p/' runtime/Makefile.unix lib/Makefile


%build
make


%install
mkdir -p %{buildroot}/%{_libdir}/ocaml
mkdir -p %{buildroot}/%{_libdir}/ocaml/caml
mkdir -p %{buildroot}/%{_libdir}/ocaml/stublibs
mkdir -p %{buildroot}/%{_bindir}

sed '/version/adirectory = "^"' %{SOURCE1} > \
    %{buildroot}/%{ocamldir}/META.camlidl

%make_install
%ocaml_files


%files -f .ofiles
%license LICENSE


%files devel -f .ofiles-devel
%doc README Changes docs tests
%license LICENSE


%changelog
* Mon Jul 01 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.11-1
- initial build
